﻿using UnityEngine;
using System.Collections;

public class ptlight1 : MonoBehaviour {
	private Light ptlight;
	float targettime;
	float timer;
	public float flashtime; // seconds

	private int objno = 0;
	private rtcmixmain RTcmix;
	int trigaudio;


	// Use this for initialization
	void Start () {
		ptlight = GetComponent<Light>();
		ptlight.intensity = 0.0f;
		ptlight.range = 0.0f;

		targettime = 3.0f;
		timer = 0.0f;
		if (flashtime == 0.0f) // in case it hasn't been set
			flashtime = 1.0f;

		// RTcmix stuff
		RTcmix = GameObject.Find ("RTcmixmain").GetComponent<rtcmixmain> ();
		RTcmix.initRTcmix (objno);

		RTcmix.SendScore ("bus_config(\"WAVETABLE\", \"aux 0-1 out\") " +
			"bus_config(\"MOOGVCF\", \"aux 0-1 in\", \"out 0-1\") " +
			"ampenv = maketable(\"line\", 1000, 0,0, 1,1, 2,0) " +
			"cfreq = maketable(\"line\", \"nonorm\", 1000, 0,500, 1,1500, 2,500) " +
			"wave = maketable(\"wave\", 1000, \"saw\") ", objno);
	}
	
	// Update is called once per frame
	void Update () {
		if (Time.time > targettime) {
			float glow = Mathf.PingPong (timer, 1.0f);
			ptlight.intensity = glow;
			ptlight.range = glow * 2.0f;

			// WAVETABLE(outsk, dur, AMP, PITCH[, PAN, WAVETABLE])
			// MOOGVCF(outsk, insk, dur, AMP, inputchan, PAN, BYPASS, FILTFREQTABLE, FILTRESONTABLE)
			if (trigaudio == 0) {
				// flashtime is doubled for rise & fall in Mathf.PingPong()
				RTcmix.SendScore ("WAVETABLE(0, " + flashtime*2.0f + ", 20000*ampenv, 8.02, 0.5, wave) " +
					"MOOGVCF(0, 0, " + flashtime*2.0f + ", 1, 0, 0.5, 0, cfreq, 0.9) ", objno);
				trigaudio = 1;
			}

			timer += (Time.deltaTime * (1.0f / flashtime));
	
			if (timer > 2.0f) { // one ping-pong cycle complete
				targettime = Time.time + 3.0f;
				timer = 0.0f;
				trigaudio = 0;
			}
		}
	}

	void OnAudioFilterRead(float[] data, int channels) {
		RTcmix.runRTcmix (data, objno, 0);
	}

	void OnApplicationQuit() {
		RTcmix.destroy (objno);
	}
}
